const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const memberships = sequelize.define(
    'memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"invited",


"active",


"suspended"

        ],

      },

invited_at: {
        type: DataTypes.DATE,
      
      

      },

joined_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  memberships.associate = (db) => {

    db.memberships.belongsToMany(db.role_assignments, {
      as: 'role_assignments',
      foreignKey: {
        name: 'memberships_role_assignmentsId',
      },
      constraints: false,
      through: 'membershipsRole_assignmentsRole_assignments',
    });

    db.memberships.belongsToMany(db.role_assignments, {
      as: 'role_assignments_filter',
      foreignKey: {
        name: 'memberships_role_assignmentsId',
      },
      constraints: false,
      through: 'membershipsRole_assignmentsRole_assignments',
    });


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity








    db.memberships.hasMany(db.role_assignments, {
      as: 'role_assignments_membership',
      foreignKey: {
          name: 'membershipId',
      },
      constraints: false,
    });

















































//end loop



    db.memberships.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.memberships.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return memberships;
};


